public class VMover implements Runnable {

    private Vehicle vehicle;

    public VMover(Vehicle vehicle) {
        this.vehicle = vehicle;
    }

    @Override
    public void run() {
        Route route = vehicle.getRoute();
        double currentLocation = vehicle.getCurrentLocation();
        if (vehicle.getCurrentStreet() == null &&
                route.getStreets()[0].capcityPoint(0,1000) < 1) {
            vehicle.setCurrentStreet(route.getStreets()[0]);
        }
        if (vehicle.getCurrentStreet() != null && vehicle.getCurrentStreet().capcityPoint(currentLocation,
                currentLocation+1000) < 1 ) {

            if (currentLocation >= vehicle.getCurrentStreet().getLength()) {
                //Move to next street
                vehicle.moveToNextStreet();
            }
            if (!vehicle.isArrivedToDest()) {
                double factor = 1-(vehicle.getCurrentStreet().capcityPoint(vehicle.getCurrentLocation(),
                        vehicle.getCurrentLocation()+1000,vehicle)) ;
                if (vehicle instanceof Bus) vehicle.move(Bus.MAX_FORWARD * factor );
                else if (vehicle instanceof Sedan) vehicle.move(Sedan.MAX_FORWARD * factor );
                else if (vehicle instanceof SUV) vehicle.move(SUV.MAX_FORWARD * factor );
                else if (vehicle instanceof Truck) vehicle.move(Bus.MAX_FORWARD * factor );
            }
        }
    }
}
